=== debian/control ===
Source: keepassxc
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
Bugs: mailto: <stevep@mxlinux.org>
XSBC-Original-Maintainer: Manolis Agkopian <m.agkopian@gmail.com>
Build-Depends: debhelper (>= 9),
               cmake (>= 3.1),
               qtbase5-dev (>= 5.2),
               qttools5-dev (>= 5.2),
               qttools5-dev-tools (>= 5.2),
               libgcrypt20-dev (>= 1.6),
               zlib1g-dev,
               libmicrohttpd-dev,
               libxi-dev,
               libxtst-dev,
               libqt5x11extras5-dev,
               libyubikey-dev,
               libykpers-1-dev
Standards-Version: 3.9.8
Homepage: https://keepassxc.org/
Vcs-Git: https://github.com/keepassxreboot/keepassxc.git
Vcs-Browser: https://github.com/keepassxreboot/keepassxc

Package: keepassxc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cross Platform Password Manager
 KeePassXC is a free/open-source password manager or safe which helps you
 to manage your passwords in a secure way. You can put all your
 passwords in one database, which is locked with one master key or a
 key-disk. So you only have to remember one single master password or
 insert the key-disk to unlock the whole database. The databases are
 encrypted using the algorithms AES or Twofish.
 .
 Additionally, KeePassXC provides keepasshttp support for use with PassIFox 
 for Mozilla Firefox and chromeIPass for Google Chrome.
