=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export LC_ALL = C.UTF-8

# main packaging script based on dh7 syntax
%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
	-DWITH_TESTS=ON -DWITH_GUI_TESTS=ON -DWITH_XC_AUTOTYPE=ON -DWITH_XC_HTTP=ON -DWITH_XC_YUBIKEY=ON

override_dh_auto_test:
	dh_auto_test -- \
	ARGS+="-E testgui"
#	xvfb-run -a --server-args="-screen 0 800x600x24" dh_auto_test -- \
#	ARGS+="-R testgui"
	
override_dh_makeshlibs:
	dh_makeshlibs -X/usr/lib/$(DEB_HOST_MULTIARCH)/keepassxc
