=== debian/changelog ===
keepassxc (2.3.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Build with all features
  * Run wrap-and-sort
  * Build-Depend on libsodium-dev, libargon2-0-dev, libcurl4-gnutls-dev
  * d/p/0002-*zxcvbn*.patch: Drop, Merged upstream
  * d/control: Point Vcs-Git and Vcs-Browser to salsa
  * d/control: Bump Standards-Version to 4.1.3

 -- Julian Andres Klode <jak@debian.org>  Sat, 10 Mar 2018 17:59:54 +0100

keepassxc (2.2.4+dfsg.1-1) unstable; urgency=medium

  * debian/watch: Drop uupdate
  * New upstream version 2.2.4+dfsg.1
    - Fixes AppStream metadata

 -- Julian Andres Klode <jak@debian.org>  Fri, 15 Dec 2017 13:19:23 +0100

keepassxc (2.2.3+dfsg.1-1) unstable; urgency=medium

  * Repack upstream tarball to remove src/zxcvbn.
    The file src/zxcvbn/dict-src.h has no source code, and the embedded
    copy is unused anway.
  * Update watch and signing-key to point to KeePassXC
  * New upstream version 2.2.3+dfsg.1
    - Fixes 16x16 message-close icon

 -- Julian Andres Klode <jak@debian.org>  Tue, 12 Dec 2017 13:07:49 +0100

keepassxc (2.2.2-1) unstable; urgency=medium

  * New upstream version 2.2.2
  * Add missing dependency on qttools5-dev (Closes: #882306)
  * Drop desktop_file_comment.patch and rebase others
  * Bump Standards-Version to 4.1.1

 -- Julian Andres Klode <jak@debian.org>  Tue, 21 Nov 2017 11:12:12 +0100

keepassxc (2.2.0-1) unstable; urgency=medium

  * Initial KeePassXC upstream version 2.2.0 (Closes: #855173)
  * Packaging changes since keepassx 2.0.3-1:
    - debian: Switch to keepassxc and Qt5
    - Enable HTTP and YubiKey features
    - desktop_file_comment.patch: Refresh using gbp pq
    - Bump Standards-Version and use debhelper 10
    - debian/control: Update maintainer
    - Use system zxcvbn.
      Thanks to Gianfranco Costamagna for providing the patch
    - Depend on libqt5x11extras5-dev
    - Turn on hardening
    - debian/copyright: Update
    - export LC_ALL=C.UTF-8 in debian/rules

 -- Julian Andres Klode <jak@debian.org>  Sat, 23 Sep 2017 21:24:46 +0200

keepassx (2.0.3-1) unstable; urgency=medium

  * New upstream release. (Closes: #845163)
  * Add missing Comment section to the desktop file. (Closes: #846274)
    - desktop_file_comment.patch

 -- Felix Geyer <fgeyer@debian.org>  Tue, 10 Jan 2017 22:33:14 +0100

keepassx (2.0.2-1) unstable; urgency=medium

  * New upstream release. (Closes: #813608)
  * d/control: Point Vcs-* to the new git repo.
  * Update watch file.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 04 Feb 2016 21:47:37 +0100

keepassx (2.0-1) unstable; urgency=medium

  * New upstream release. (Closes: #707634)
    - Completely rewritten compared to 0.x series
      (closes: #707634, #685533, #714357, #763083, #791858)
    - pronouncable password generator has been dropped (closes: #645499)

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 09 Jan 2016 19:24:30 -0500

keepassx (2.0~beta2-1) experimental; urgency=medium

  * New upstream beta release.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 11 Sep 2015 23:55:20 +0200

keepassx (2.0~beta1-1) experimental; urgency=medium

  * New upstream beta release.
  * Update copyright file.
  * Bump Standards-Version to 3.9.6, no changes needed.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 19 Jul 2015 20:49:14 +0200

keepassx (2.0~alpha6-1) experimental; urgency=medium

  * New upstream alpha release.
    - Supports the .kdbx (KeePass 2) file format.
  * Drop fix_ftbfs_gcc47.diff, not needed anymore.
  * Switch debian/rules to use cmake and run unit tests.
  * Redo debian/copyright.
  * Update watch file.

 -- Felix Geyer <fgeyer@debian.org>  Fri, 15 Aug 2014 00:00:01 +0200

keepassx (0.4.3+dfsg-0.1) unstable; urgency=high

  * Non-maintainer upload.
  * Use repackaged upstream tarball by Felix Geyer, which replaces icons of
    unknown origin (clientic.png text_block.png text_bold.png text_center.png
    text_italic.png text_left.png text_right.png text_under.png) and adds full
    text of associated licenses (LICENSE.LGPL-2.1 LICENSE.LGPL-3).
  * Use patch by Felix Geyer to update debian/copyright with the origin and
    license of png files, and update README.source accordingly.
  * Additionally, update debian/copyright to document the origin and copyright
    of go-*.png and help_about.png icons (project Oxygen, and license CC-BY-SA
    3.0 or LGPL respectively).
  * The above three items close #698832
  * Update debian/watch for version mangling.
  * Setting high urgency due to RC bug.

 -- Serafeim Zanikolas <sez@debian.org>  Wed, 20 Mar 2013 14:04:39 +0100

keepassx (0.4.3-2) unstable; urgency=low

  * Fix FTBFS with gcc 4.7. (Closes: #667224)
    - Add fix_ftbfs_gcc47.diff
  * Bump Standards-Version to 3.9.3, no changes needed.
  * Enable parallel building.
  * Switch to debhelper compat level v9.
    - Exports build flags.
  * Use the qmake_qt4 dh buildsystem.
  * Install application icon in various resolutions.
    - Add debian/keepassx.svg
    - Build-depend on imagemagick and librsvg2-bin.

 -- Felix Geyer <debfx-pkg@fobos.de>  Thu, 05 Apr 2012 13:10:22 +0200

keepassx (0.4.3-1) unstable; urgency=low

  * New upstream release. (Closes: #572614)
    - Fixes FTBFS with binutils-gold. (Closes: #554982)
  * Switch to new source format 3.0 (quilt).
  * Bump Standards-Version to 3.8.4, no changes needed.

 -- Felix Geyer <debfx-pkg@fobos.de>  Sun, 07 Mar 2010 00:42:51 +0100

keepassx (0.4.1-1) unstable; urgency=low

  * New upstream release. (LP: #431798)
  * Bump debhelper to dh 7.
    - increase debian/compat to 7.
    - simplify debian/rules.
  * Bump Standards-Version to 3.8.3, no changes needed.

 -- Felix Geyer <debfx-pkg@fobos.de>  Thu, 17 Sep 2009 15:21:00 +0200

keepassx (0.4.0-1) unstable; urgency=low

  * New upstream release. (Closes: #522488)
  * adapt debian/watch file to new upstream naming style.

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 04 Apr 2009 11:39:24 +0200

keepassx (0.3.4-2) unstable; urgency=low

  [ Felix Geyer ]
  * introduce quilt
